#ident	"$Header: /var/cvsroot/htdb/src/dso/google.c,v 1.6 2004/05/21 22:52:26 del Exp $"

#include	"htdb.h"

#define SERVER_PORT 80

char	*fetchGoogleSendMessage(char *key, char *q, int start, int maxResults, bool_t filter, char *restric, bool_t safeSearch, char *lr)
{
	htdb_setptrval("google", "Key", key);
	htdb_setptrval("google", "Q", q);
	htdb_setptrint("google", "Start", start);
	htdb_setptrint("google", "MaxResults", maxResults);
	htdb_setptrval("google", "Filter", (BOOL_TRUE == filter) ? "true" : "false");
	htdb_setptrval("google", "Restrict", restric);
	htdb_setptrval("google", "SafeSearch", (BOOL_TRUE == safeSearch) ? "true" : "false");
	htdb_setptrval("google", "LR", lr);

	{
		char	*body = htdb_script("googleSearchBody"),
				*header;
		spaceData	b;

		htdb_setptrint("google", "BodyBytes", strlen(body) - 6);

		header = htdb_expand(htdb_getptrval("google", "SearchHeader"));

		data_init(&b);

		thing_append(&b, header, FUNC_CALCULATES_SIZE, BUF_LIMIT_BIG);
		thing_appendChar(&b, '\n', BUF_LIMIT_BIG);
		thing_append(&b, body, FUNC_CALCULATES_SIZE, BUF_LIMIT_BIG);
		thing_appendChar(&b, '\n', BUF_LIMIT_BIG);
		thing_appendChar(&b, '\n', BUF_LIMIT_BIG);

		free(body);
		free(header);

		return b.value;
	}
}

char	*doGoogleSearch(char *key, char *q, int start, int maxResults, bool_t filter, char *restric, bool_t safeSearch, char *lr)
{
	char	*sendMessage = fetchGoogleSendMessage(key, q, start, maxResults, filter, restric, safeSearch, lr);
	if (sendMessage && *sendMessage) {
		int	sd;
		struct sockaddr_in	localAddr, servAddr;
		struct hostent	*h;
		char	*host = htdb_getptrval("google", "SearchHost");
		spaceData	b;
		data_init(&b);

		if ((h = gethostbyname(host)) == NULL) {
			log_fatal("buh", "unknown host '%s'\n", host);
			return strdup("");
		}

		servAddr.sin_family = h->h_addrtype;
		memcpy((char *) &servAddr.sin_addr.s_addr, h->h_addr_list[0], h->h_length);
		servAddr.sin_port = htons(SERVER_PORT);

		/*
			create socket
		 */
		if ((sd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
			log_fatal("buh", "cannot open socket ");
			return strdup("");
		}

		/*
			bind any port number
		 */
		localAddr.sin_family = AF_INET;
		localAddr.sin_addr.s_addr = htonl(INADDR_ANY);
		localAddr.sin_port = htons(0);

		if (bind(sd, (struct sockaddr *) &localAddr, sizeof(localAddr)) < 0) {
			log_fatal("buh", "cannot bind port TCP %u\n",SERVER_PORT);
			return strdup("");
		}
			
		/*
			connect to server
		 */
		if (connect(sd, (struct sockaddr *) &servAddr, sizeof(servAddr)) != 0) {
			log_fatal("buh", "cannot connect");
			return strdup("");
		}

		{
			char	line[BUF_LIMIT_SMALL + 1];
			int		n;

			if ((n = send(sd, sendMessage, strlen(sendMessage), 0)) < 0) {
				log_fatal("buh", "cannot send data ");
				close(sd);
				return strdup("");
			}
			log_fatal("buh", "%d bytes sent\n", n);

			while ((n = recv(sd, line, BUF_LIMIT_SMALL, 0)) > 0) {
				log_fatal("read", "%d bytes", n);
				log_fatal("read", line);
				thing_append(&b, line, n, BUF_LIMIT_BIG);
			}
		}

		close(sd);
		free(sendMessage);
		return b.value;
	}
	return strdup("");
}
